﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ConsoleApplication1
{
    class Client
    {
        public class App : Ice.Application
        {
            public override int run(string[] args)
            {
                Ice.ObjectAdapter adapter = communicator().createObjectAdapterWithEndpoints("TestPublisher", "default -p 10008 -h 192.168.0.101");
                adapter.activate();
                
                IceStorm.TopicManagerPrx topicManager = 
                    IceStorm.TopicManagerPrxHelper.checkedCast(communicator().stringToProxy("DemoIceStorm/TopicManager:default -p 10000 -h 192.168.0.101"));

                IceStorm.TopicPrx targetTopic;
                string topicNameTarget = "Target1";
                try
                {
                    targetTopic = topicManager.retrieve(topicNameTarget);
                }
                catch (IceStorm.NoSuchTopic)
                {
                    targetTopic = topicManager.create(topicNameTarget);
                }

                string topicName = "Source1";
                IceStorm.TopicPrx sourceTopic;
                try
                {
                    sourceTopic = topicManager.retrieve(topicName);
                }
                catch (IceStorm.NoSuchTopic)
                {
                    sourceTopic = topicManager.create(topicName);
                    sourceTopic.link(targetTopic, 0);
                }

                Demo.ClockPrx clock = Demo.ClockPrxHelper.uncheckedCast(sourceTopic.getPublisher());


                for (int i = 0; i < 100; i++)
                {
                    clock.tick(i.ToString());
                    Thread.Sleep(500);
                }

                //communicator().waitForShutdown();
                return 0;
            }
        }

        public static void Main(string[] args)
        {
            var app = new App();
            int status = app.main(args);
            Console.ReadLine();
            if (status != 0)
            {
                Environment.Exit(status);
            }

        }
    }
}
