﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Subscriber
{
    class Client
    {
        public class App : Ice.Application
        {
            public override int run(string[] args)
            {
                Ice.ObjectAdapter adapter = communicator().createObjectAdapterWithEndpoints("TestPublisher", "default -p 10099 -h 192.168.0.101");
                adapter.activate();

                IceStorm.TopicManagerPrx topicManager =
                    IceStorm.TopicManagerPrxHelper.checkedCast(communicator().stringToProxy("DemoIceStorm/TopicManager:default -p 10000 -h 192.168.0.101"));


                var clockObserverTargetPrx = Demo.ClockPrxHelper.checkedCast(
                   adapter.add(new ClockObserverTargetI(), communicator().stringToIdentity("Target_Observer.subscriber")));

                var clockObserverSourcePrx = Demo.ClockPrxHelper.checkedCast(
                    adapter.add(new ClockObserverSourceI(), communicator().stringToIdentity("Target_Source.subscriber")));
                try
                {
                    IceStorm.TopicPrx sourceTopic = topicManager.retrieve("Source1");
                    sourceTopic.subscribeAndGetPublisher(null, clockObserverSourcePrx);

                    IceStorm.TopicPrx targetTopic = topicManager.retrieve("Target1");
                    targetTopic.subscribeAndGetPublisher(null, clockObserverTargetPrx);
                }
                catch (IceStorm.AlreadySubscribed)
                {
                    //expected
                }


                communicator().waitForShutdown();
                return 0;
            }
        }

        public static void Main(string[] args)
        {
            var app = new App();
            int status = app.main(args);
            Console.ReadLine();
            if (status != 0)
            {
                Environment.Exit(status);
            }

        }
    }
}
